# JMeter Advanced Level Training (Online)
### Become a Performance Test Engineer in 2021 with Apache JMeter 

Welcome to the JMeter Advanced Level Training conducted by Pragmatic Training!
We will use this project to share the JMeete test plans , daily plans, daily notes, references and other artifacts related to the training.

## Goals 
You will be able to learn frequently used **advanced features** of Apache JMeter and apply them in your real projects effectively and efficiently.

---
### Dates
* Day 1 : 
* Day 2 : 
* Day 3 : 
* Day 4 : 
* Day 5 : 

### Time 
* EST : 10:00 a.m. to 12:30 p.m.
* IST : 07:30 p.m. to 10:00 p.m.
---
## Prerequisites

1. You should be comfortable in creating test scripts (JMX) with JMeter HTTP(s) Test Script Recorder, Manage sessions
   with Post-Processors, run tests, save the test results and analyse the results with the listeners
2. Knowledge of HTML and web technologies
3. Basic programming knowledge
---
## Setup training environment
Please ensure this GitHub repository is cloned into your machine (IntelliJ IDEA) to **practice** the lessons learned from the training.

1. Install JDK 1.8
2. Install IntelliJ IDEA community edition
3. Install Git
4. Configure IntelliJ IDEA with Git
5. Clone the [training project](https://github.com/pragmatictesters/Pragmatic-Learning-JMeter-July-2021..git) from GitHub

---
## Course outline
Following is the high level course outline for the training.

1. [Day1-Topic1 : JMeter Plugins](docs/Session1-Plan.md)
2. [Day1-Topic2 : File uploading with JMeter](docs/Session1-Plan.md)
3. [Day2-Topic1 : Simulating Throughput](docs/Session2-Plan.md)
4. [Day2-Topic2 : API Testing with JMeter](docs/Session2-Plan.md)
5. [Day3-Topic1 : Optimizing JMeter performance](docs/Session3-Plan.md)
6. [Day3-Topic2 : Resource monitoring](docs/Session3-Plan.md)
7. [Day4-Topic1 : Mobile testing](docs/Session4-Plan.md)
8. [Day4-Topic2 : Testing applications with HTTPS](docs/Session4-Plan.md)
9. [Day5-Topic1 : Distribute testing](docs/Session5-Plan.md)
10. [Day5-Topic2 : Running your tests with Redline13](doc/Session5-Plan-21May2021.md)

---
## Practice sessions and homework 
There will be practice sessions at the end of each training day pertaining to the topics covered during the day.
Homework will be given to practice and combine the lessons learned. 

* Duration : 30 min to 1 hour 

---
## Certificate 
The delegates will receive a participation certificate from Redline13 after completing the 5 days program successfully.


## Questions and Answers 
Questions and answers will be tracked through the [Issues](https://github.com/pragmatictesters/Pragmatic-Learning-JMeter-July-2021/issues)

---
## References

1. [JMeter official website](https://jmeter.apache.org)
2. [JMeter Plugins](https://jmeter-plugins.org)
3. [Glossary for performance testers](http://pragmatictestlabs.com/2018/05/08/glossary_for_performance_testers/)
4. Sample applications 
    1. [Web Testing](http://hrm.pragmatictestlabs.com)
    2. [API Testing ]()
    3. [Mobile Testing]()

5. [JMeter Basic videos ](https://youtu.be/3sXLi2P6-6g)
6. [Performance Testing Guidance for Web Applications](https://docs.microsoft.com/en-us/previous-versions/msp-n-p/bb924375(v=pandp.10))

